AutoCAD顧問
還沒有註冊嗎...即日起免費註冊,所有最完整的AutoCAD討論、教學及資源都在論壇裡喔~

[已解決]lisp框選時的外框

上一篇主題 下一篇主題 向下

[已解決]lisp框選時的外框

發表 由 awi 于 周五 21 6月 2013 - 3:11

(defun c:zw(/ zw1 zw2)
  (setvar "osmode" 4311)
  (setq zw1(getpoint "指定第一角點"))
  (setq zw2(getpoint "指定對角點"))
  (command "zoom" "w" zw1 zw2)
  (prin1)
)

我要怎麼寫在框選的時候才會有框選外框?


awi 在 周五 21 6月 2013 - 9:26 作了第 2 次修改
avatar
awi
一般會員
一般會員

文章總數 : 74
年齡 : 34
來自 : 新北市
職業 : 電機技師事務所
愛好 : 新奇有趣的事物
個性 : 固執
使用年資 : 6
使用版本 : 2012
經驗值 : 1998
威望值 : 42
注冊日期 : 2013-05-03
男 白羊座 豬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 ginse0727 于 周五 21 6月 2013 - 5:15

選單一物件,用entsel,選多數物件要用ssget.
avatar
ginse0727
高級會員
高級會員

文章總數 : 256
年齡 : 43
來自 : 台北巿
職業 : 帷幕牆
愛好 : 電玩,漫畫,網路小說
個性 : 宅男/正直/死腦筋
使用年資 : 退伍後工作迄今,10年以上
使用版本 : 2012
積分 : 14
經驗值 : 4173
威望值 : 491
發帖精華 : 1
注冊日期 : 2010-07-12
經典問與答讀者 藍鵲61號
2011聚會勳章 男 獅子座 虎

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 shenhung 于 周五 21 6月 2013 - 5:37

若只是要有矩形框的效果的話!!
(setq zw2 (getcorner zw1 "指定對角點"))
avatar
shenhung
高級會員
高級會員

文章總數 : 238
年齡 : 50
來自 : 新北市
職業 : 塑膠模具設計.AUTOLISP
愛好 : 音樂
個性 : 隨和
使用年資 : 18年
使用版本 : 2010
積分 : 15
經驗值 : 4951
威望值 : 916
注冊日期 : 2009-06-03
男 摩羯座 馬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 awi 于 周五 21 6月 2013 - 7:09

(setq zw2 (getcorner zw1 "指定對角點"))
我就是要這個,非常感謝歐~~

但我發現了另一個奇怪的問題,我如果把這3個寫在一個檔案命名"zoom.lsp"框框就不會出現,單獨寫一個檔案命名"zw.lsp"框框就會出現,不過都可以執行,這是為啥??
而且寫在一個檔案裡連回應的對話都會顯示在同一行,變成這樣"指定第一角點指定對角點",然後這一行不會出現"-----zw-----"。

(defun c:zw(/ zw1 zw2);顯示框選範圍
  (setvar "osmode" 4311)
  (setq zw1(getpoint "\n指定第一角點"))
  (setq zw2(getcorner zw1 "\n指定對角點"))
  (command "zoom" "w" zw1 zw2)
  (prompt "\n-----zw-----") 
  (prin1)
)

(defun c:ze();顯示實際範圍
  (command "zoom" "e")
  (prompt "\n-----ze-----")
  (prin1)
)


(defun c:zp();顯示前一畫面範圍
  (command "zoom" "p")
  (prompt "\n-----zp-----")
  (prin1)
)
avatar
awi
一般會員
一般會員

文章總數 : 74
年齡 : 34
來自 : 新北市
職業 : 電機技師事務所
愛好 : 新奇有趣的事物
個性 : 固執
使用年資 : 6
使用版本 : 2012
經驗值 : 1998
威望值 : 42
注冊日期 : 2013-05-03
男 白羊座 豬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 shenhung 于 周五 21 6月 2013 - 9:08

我剛測了一下.!!我的是都沒問題.!! 測試版本是2010 
可能要其他人再幫你測一下.看有沒問題.!! 

zoom 是autocad 標準指令. 所以我是沒寫LISP.
zw ze zp 這3個.我是直接在MENU檔內.把巨集設在按鍵上!!不用下指令.也不用Enter .就直接執行.
avatar
shenhung
高級會員
高級會員

文章總數 : 238
年齡 : 50
來自 : 新北市
職業 : 塑膠模具設計.AUTOLISP
愛好 : 音樂
個性 : 隨和
使用年資 : 18年
使用版本 : 2010
積分 : 15
經驗值 : 4951
威望值 : 916
注冊日期 : 2009-06-03
男 摩羯座 馬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 awi 于 周五 21 6月 2013 - 9:24

應為我比較習慣鍵盤下指令,所以才把他寫成LISP

我剛剛試了一下,果然是LISP檔名的問題。
把"zoom.lsp"改成"zom.lsp"就都正常了。
應該是BUG吧!  我的是2012 感謝歐~~
avatar
awi
一般會員
一般會員

文章總數 : 74
年齡 : 34
來自 : 新北市
職業 : 電機技師事務所
愛好 : 新奇有趣的事物
個性 : 固執
使用年資 : 6
使用版本 : 2012
經驗值 : 1998
威望值 : 42
注冊日期 : 2013-05-03
男 白羊座 豬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 djh1006 于 周日 30 6月 2013 - 15:34

awi 寫到:應為我比較習慣鍵盤下指令,所以才把他寫成LISP

我剛剛試了一下,果然是LISP檔名的問題。
把"zoom.lsp"改成"zom.lsp"就都正常了。
應該是BUG吧!  我的是2012 感謝歐~~
誠如shenhung說的,zoom是autocad的內部指令,所以不能把它當成lisp的指令名稱(並不是BUG哦),否則auotcad會先執行自己的內部指令
當然也有指令可以先把zoom的內部指令取消,再把自己的zoom.lsp載入即可使用自己寫的zoom指令了,不過不建議這麼做,至於什麼指令可取消內部指令zoom,很抱歉,我忘了,在論壇裡有人提到,忘了在哪一篇文章裡,自己爬文吧,不好意思哦
avatar
djh1006
中級會員
中級會員

文章總數 : 156
年齡 : 46
來自 : 彰化縣員林鎮中山路二段369巷二弄15-14號
職業 : 沖壓模具設計工程師
愛好 : UG,SOLIDWORKS,AUTOCAD 2D,autolisp
個性 : 內向偏外
使用年資 : 18以上
使用版本 : 2014
積分 : 6
經驗值 : 3347
威望值 : 294
注冊日期 : 2011-06-16
男 獅子座 豬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 Tiger&蘋果爸 于 周一 1 7月 2013 - 3:03

djh1006 寫到:誠如shenhung說的,zoom是autocad的內部指令,所以不能把它當成lisp的指令名稱(並不是BUG哦),否則auotcad會先執行自己的內部指令
當然也有指令可以先把zoom的內部指令取消,再把自己的zoom.lsp載入即可使用自己寫的zoom指令了,不過不建議這麼做,至於什麼指令可取消內部指令zoom,很抱歉,我忘了,在論壇裡有人提到,忘了在哪一篇文章裡,自己爬文吧,不好意思哦
補充:把內部指令取消是這一篇文章!
http://www.autocad-tw.com/t9104p15-topic#106639
竊喜 

____________________________________________________________________________________
avatar
Tiger&蘋果爸
系統管理員
系統管理員

文章總數 : 17080
年齡 : 41
來自 : 台北市文山區
職業 : AutoCAD顧問
愛好 : 蹓狗/戶外活動/拍照
個性 : 幽默/樂觀/善良
使用年資 : 15↑
使用版本 : AutoCAD 2016
經驗值 : 63953
威望值 : 12657
注冊日期 : 2008-04-23
2D基礎函授 2D進階函授 3D基礎函授 https://i11.servimg.com/u/f11/19/71/67/71/2d3d10.png2D+3D線上 顧問外掛程式 經典問與答讀者 藍鵲1號
2009聚會勳章 2010聚會勳章 2011聚會勳章 2012聚會勳章 2013勳章-2D基礎 2014聚會勳章 2015聚會勳章 2016聚會勳章 串連貼紙成功 男 水瓶座 兔

http://mypaper.pchome.com.tw/kv1012tiger

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 awi 于 周三 10 7月 2013 - 1:58

Tiger&蘋果爸 寫到:
djh1006 寫到:誠如shenhung說的,zoom是autocad的內部指令,所以不能把它當成lisp的指令名稱(並不是BUG哦),否則auotcad會先執行自己的內部指令
當然也有指令可以先把zoom的內部指令取消,再把自己的zoom.lsp載入即可使用自己寫的zoom指令了,不過不建議這麼做,至於什麼指令可取消內部指令zoom,很抱歉,我忘了,在論壇裡有人提到,忘了在哪一篇文章裡,自己爬文吧,不好意思哦
補充:把內部指令取消是這一篇文章!
http://www.autocad-tw.com/t9104p15-topic#106639
竊喜 
可是我並不是把zoom設定成指令,我只是把他設為LISP的檔案名,指令是ZW ZE ZP,這樣也會有衝突嗎?
avatar
awi
一般會員
一般會員

文章總數 : 74
年齡 : 34
來自 : 新北市
職業 : 電機技師事務所
愛好 : 新奇有趣的事物
個性 : 固執
使用年資 : 6
使用版本 : 2012
經驗值 : 1998
威望值 : 42
注冊日期 : 2013-05-03
男 白羊座 豬

回頂端 向下

回復: [已解決]lisp框選時的外框

發表 由 Tiger&蘋果爸 于 周三 10 7月 2013 - 2:59

awi 寫到: 可是我並不是把zoom設定成指令,我只是把他設為LISP的檔案名,指令是ZW ZE ZP,這樣也會有衝突嗎?
你可以直接測試看看,如果不行表示有衝突!
竊喜 

如果只是要加自訂指令,我建議你可以透過以下方式:
[教學]LISP快捷鍵-視窗工具

____________________________________________________________________________________
avatar
Tiger&蘋果爸
系統管理員
系統管理員

文章總數 : 17080
年齡 : 41
來自 : 台北市文山區
職業 : AutoCAD顧問
愛好 : 蹓狗/戶外活動/拍照
個性 : 幽默/樂觀/善良
使用年資 : 15↑
使用版本 : AutoCAD 2016
經驗值 : 63953
威望值 : 12657
注冊日期 : 2008-04-23
2D基礎函授 2D進階函授 3D基礎函授 https://i11.servimg.com/u/f11/19/71/67/71/2d3d10.png2D+3D線上 顧問外掛程式 經典問與答讀者 藍鵲1號
2009聚會勳章 2010聚會勳章 2011聚會勳章 2012聚會勳章 2013勳章-2D基礎 2014聚會勳章 2015聚會勳章 2016聚會勳章 串連貼紙成功 男 水瓶座 兔

http://mypaper.pchome.com.tw/kv1012tiger

回頂端 向下

上一篇主題 下一篇主題 回頂端


 
這個論壇的權限:
無法 在這個版面回復文章